#!/bin/sh

# Überprüfe die Referenzen


if [ $# -eq 0 ]; then
  DIR="../References"
else
  DIR="$1"
fi
test -f FreeDoko && rm FreeDoko

mkdir -p "/tmp/${LOGNAME}/FreeDoko.check_reference/src"

#CXXFLAGS="-Wall -Werror -Wno-parentheses -pipe -O0 -ggdb"
CXXFLAGS="-Wall -Werror -Wno-parentheses -pipe -O2" \
 make \
 USE_UI_GTKMM=false \
 USE_UI_TEXT=false \
 USE_SOUND=false \
 USE_BOOST=true \
 FREEDOKO_WORKING_DIRECTORY=/tmp/${LOGNAME}/FreeDoko.check_reference/src

test -f ./FreeDoko || exit

cd ../data
../src/FreeDoko -r "$DIR" --ui=none

cd "$DIR"

grep -h -v OK References.report.csv \
  | grep "^[^;]*[0-9]\+\(_[0-9]\+\)\?.Reference.FreeDoko" \
  | sort -n

tail -n 5 References.report.csv \
  | sed "s/\;/\t/g";

echo
echo "Einträge überprüft: "`grep "^[ \t]*check" *.Reference.FreeDoko **/*.Reference.FreeDoko | wc -l`

# Die kaputten Referenzen in ein separates Verzeichnis kopiert
rm -rf /tmp/FreeDoko.References.failed
mkdir /tmp/FreeDoko.References.failed
grep "^[^;]*[0-9]\+_\?[0-9]*.Reference.FreeDoko;" References.report.csv \
  | grep -v OK \
  | awk -F \; '{printf("  %s\n", $1)}' \
  | sort -n \
  >/tmp/FreeDoko.References.failed/References.failed

echo "Kaputt: "
grep -v "_broken" /tmp/FreeDoko.References.failed/References.failed
echo

for f in References.report.csv `cat /tmp/FreeDoko.References.failed/References.failed`; do
  mkdir -p /tmp/FreeDoko.References.failed/"`dirname $f`"
  cp "$f" "/tmp/FreeDoko.References.failed/$f"
done

# Die wieder funktionierenden kaputten Referenzen anzeigen
echo "Wieder heil:"
ls **/*FreeDoko | grep _broken \
  | while read f; do
grep -q "$f" /tmp/FreeDoko.References.failed/References.failed \
  || echo "$f"
done
echo
